/*
 *  Perform some basic fp sanity checks
 *  
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
	char f[] = "1.0";
	char buf[256];
	double x;
#ifdef __arm__
	unsigned long *xp = (unsigned long *)(&x);
#endif

	/* Test if strtod and sprintf work with fp numbers. If not, this indicates
	 * that the program is compiled with fpa toolchain and linked with a vfp
	 * toolchain (or the other way round)
	 */
	printf("Testing strtod... ");
	x = strtod(f, NULL);
	if (x != 1.0) {
		printf("FAIL: strtod() #####\n");
		return -1;
	}
	printf("OK\n");

	printf("Testing sprintf... ");
	sprintf(buf, "%1.1f\n",1.0);
	if (strncmp(buf, "1.0", 3)) {
		printf("FAIL: sprintf() : %s #####\n",buf);
		return -1;
	}
	printf("OK\n");

#ifdef __arm__
	/*  Test wether we use a fpa or vfp Toolchain. We want vfp because
	 *  it's newer, shinier and programs like qt depend on this notaion
	 */
	printf("Testing vfp <-> fpa...");
	x = 1;
	if (*xp == 0 && *(xp + 1) == 0x3ff00000) {
		printf("OK (using vfp)\n");
		goto out;
	} else if (*xp == 0x3ff00000 && *(xp + 1) == 0x0) {
		printf("FAIL: (using fpa) ####\n");
		return -1;
	} else {
		printf("FAIL: unknown floating point notation ####\n");
		return -1;
	}

 out:
#endif
	printf("PASSED\n");
	return 0;
}
